<template>
  <div>
    <Multiselect
      v-if="isMultiSelect && config.filter"
      ref="multiselect"
      :value="value"
      :options="config.filter"
      :multiple="true"
      :close-on-select="false"
      :clear-on-select="true"
      label="name"
      track-by="value"
      @input="onChange"
      :placeholder="placeholder"
    />
    <input
      v-else-if="isTextFilter"
      :value="value[0]"
      @input="onTextSearchChange"
      :placeholder="placeholder"
    />
  </div>
</template>
<script>
import Multiselect from "vue-multiselect";
import {
  FILTER_ANY,
  FILTER_MULTI_SELECT,
  FILTER_TEXT_SEARCH,
} from "../../lib/constants";
export default {
  data() {
    return { model: [] };
  },
  components: {
    Multiselect,
  },
  name: "Header",
  props: {
    config: {},
    value: {},
  },
  computed: {
    placeholder() {
      return `Filter by ${this.config?.text}`;
    },
    isMultiSelect() {
      return this.config.filterType === FILTER_MULTI_SELECT;
    },
    isTextFilter() {
      return this.config.filterType === FILTER_TEXT_SEARCH;
    },
  },
  methods: {
    onTextSearchChange($event) {
      const { value } = $event.target;
      if (value) {
        this.$emit("input", [value]);
      } else {
        this.$emit("input", []);
      }
    },
    onChange(value) {
      if (value.some((x) => x.value === FILTER_ANY)) {
        this.model = [];
        this.$emit("input", []);
        this.$refs.multiselect.deactivate();
      } else {
        this.$emit("input", value);
      }
    },
  },
};
</script>
<style scoped>
div {
  min-width: 400px;
  max-width: 600px;
}
input {
  width: 100%;
  min-height: 40px;
}
</style>
